/************************************************
 * cyclone32_mhz.c                              *
 * Peter Schrammel                              *
 * e0125015@student.tuwien.ac.at                *
 * 2004-01-22                                   *
 * test mhz_counter                             *
 ************************************************/
#include "nios.h"

//timer = 1 sec
#define TIMER_PERIOD_LOW        (0x6C00)
#define TIMER_PERIOD_HIGH       (0x02DC)


/* read mhz_counter value every second */
void isr_timer(int context)
  {
  nr_uart_txhex32(na_mhz_counter->np_cnt_val);
  nr_uart_txcr();
  na_timer->np_timerstatus |= 0x01;
  }

int main(void)
  {
  nr_installuserisr(na_timer_irq,&isr_timer,0);
  na_timer->np_timercontrol |= 0x08; // stop timer 
  na_timer->np_timercontrol = 0x03;  // continuous mode, enable ir
  na_timer->np_timerperiodl = TIMER_PERIOD_LOW;
  na_timer->np_timerperiodh = TIMER_PERIOD_HIGH;
  na_timer->np_timercontrol |= 0x04; // start timer 
  }
